//
//  AddressBookAdaptor.h
//  Enroll
//
//  Created by SatoAkira on Wed Sep 18 2002.
//  Copyright (c) 2002 SatoAkira. All rights reserved.
//

#import <Foundation/Foundation.h>


@interface AddressBookAdaptor : NSObject {

}

+ (AddressBookAdaptor *)adaptor;
- (NSData *)vCardRepresentation:(NSDictionary *)aDic image:(NSData *)tiffData at:(NSString *)index;
- (BOOL)isExistsAtAddressBook:(NSString *)index;
- (BOOL)saveAperson:(NSDictionary *)aDic image:(NSData *)tiffData at:(NSString *)index;
- (BOOL)saveAgroup:(NSURL *)source enroll:(NSDictionary *)dic group:(NSString *)groupName images:(NSFileWrapper *)imagesWrapper;

@end
