//
//  AppController.m
//  Enroll
//
//  Created by 佐藤 昭 on Tue Jul 16 2002.
//  Copyright (c) 2002 SatoAkira. All rights reserved.
//

#import "AppController.h"
#import "MainDocument.h"

@implementation AppController


- (NSApplicationTerminateReply)applicationShouldTerminate:(NSApplication *)sender {
	NSDocumentController *dController = [NSDocumentController sharedDocumentController];
	NSArray *documents = [dController documents];
	NSUInteger i = [documents count];
	while (i--)
		[(MainDocument *)[documents objectAtIndex:i] shouldCloseWindowController:[[documents objectAtIndex:i] windowController] delegate:nil shouldCloseSelector:@selector(close:) contextInfo:NULL];
	// [[NSDocumentController sharedDocumentController] closeAllDocumentsWithDelegate:[[NSDocumentController sharedDocumentController] currentDocument] didCloseAllSelector:@selector(documentController:didCloseAll:contextInfo:) contextInfo:NULL]; //
	return NSTerminateNow;
}
- (BOOL)applicationShouldTerminateAfterLastWindowClosed:(NSApplication *)theApplication {  // override //
    return NO;
}
- (void)applicationDidResignActive:(NSNotification *)aNotification {  // override //
    NSUInteger count = (nil != [[NSDocumentController sharedDocumentController] documents]) ? [[[NSDocumentController sharedDocumentController] documents] count] : 0;
    if (0 == count)
        [NSApp terminate:[aNotification object]];
}

@end
