/* HagakiPrint.h created by SatoAkira on Mon 19-Jul-1999 */

#import <AppKit/AppKit.h>
#import <ASPageLayoutAccessory/ASPageLayoutAccessory.h>
#import "HagakiBarcodeView.h"
#import <ASForm/ASForm.h>

@interface HagakiPrint : NSWindowController <NSWindowDelegate>
{
	IBOutlet NSBox *hagakiBox;
	IBOutlet NSButton *printButton;
	IBOutlet NSButton *pageSetupButton;
	IBOutlet NSTextView *zipTextView;
	IBOutlet NSTextView *addressTextView;
	IBOutlet NSTextView *nameTextView;
	IBOutlet NSPopUpButton *misterPopUp;
	IBOutlet NSButton *misterPositionSwitch;
	IBOutlet NSTextField *stampField;
	IBOutlet ASForm *barcodeContentForm;
	IBOutlet HagakiBarcodeView *barcodeView;
	IBOutlet NSTextField *countryField;
	NSString *misterString;
	NSPrintInfo *printInfo;
	BOOL releasedWhenClosed;
	BOOL papersetSuccess;
}

+ (HagakiPrint *)hagakiPrint;
- (IBAction)printDocument:(id)sender;
- (IBAction)setMisterString:(id)sender;
- (IBAction)setMisterPosition:(id)sender;
- (IBAction)runPageLayout:(id)sender;
- (IBAction)setBarcodeContent:(id)sender;
- (NSPrintInfo *)printInfo;

@end
