//
//  MainWindowController.h
//  Enroll
//
//  Created by ç≤ì° è∫ on Tue Jul 16 2002.
//  Copyright (c) 2002 SatoAkira. All rights reserved.
//

#import <AppKit/AppKit.h>
#import <ASWebView/ASImageView.h>
#import "ASSoundController.h"
#import <ASForm/ASForm.h>


@interface MainWindowController : NSWindowController
{
	IBOutlet NSComboBox *indexCombo;
	IBOutlet NSTextField *indexTitleField;
	IBOutlet NSComboBox *nameCombo;
	IBOutlet NSTextField *nameTitleField;
	IBOutlet NSTextField *nameKanaField;
	IBOutlet NSComboBox *countryCombo;
    IBOutlet ASForm *rootIndexForm,*postForm,*zipForm,*prefectureForm,*cityForm,*townForm,*addressForm,*telNumberForm,*faxNumberForm,*phsNumberForm,*othersForm,*typeForm,*birthDayForm,*locateXForm,*locateYForm,*locateZForm;
	IBOutlet ASForm *changeIndexForm,*groupnameForm;
	IBOutlet NSTextField *prefectureKanaField;
	IBOutlet NSTextField *cityKanaField;
	IBOutlet NSTextField *townKanaField;
	IBOutlet NSComboBox *emailCombo;
	IBOutlet NSTextField *emailTitleField;
	IBOutlet NSComboBox *urlCombo;
	IBOutlet NSTextField *urlTitleField;
	IBOutlet NSButton *locateButton;
	IBOutlet ASImageView *pictureView;
	IBOutlet NSButton *imageDeleteButton;
	IBOutlet NSPathControl *picturePathControl;
	IBOutlet NSButton *deleteButton;
	IBOutlet NSButton *indexChangeButton;
	IBOutlet NSButton *enrollButton;
	IBOutlet NSButton *goURLButton;
	IBOutlet NSButton *postalButton;
	IBOutlet NSTextField *postalDrawerTitleField;
	IBOutlet NSTextField *zipDicTitleField;
	IBOutlet NSTextField *zipDicField;
	IBOutlet NSButton *prefecSetButton;
	IBOutlet NSButton *prefecCancelButton;
	IBOutlet NSProgressIndicator *prefecProgress;
	IBOutlet NSPopUpButton *zipPopUp;
	IBOutlet NSButton *zipButton;
	IBOutlet NSButton *setPrefectureButton;
	IBOutlet NSWindow *prefecWindow;
	IBOutlet NSButton *companyButton;
	IBOutlet NSMatrix *prefecMatrix;
	IBOutlet NSButton *changeOKButton;
	IBOutlet NSWindow *addressbookWindow;
	IBOutlet NSButton *addressbookOKButton;
	IBOutlet NSButton *addressbookCancelButton;
	IBOutlet NSProgressIndicator *addressbookProgress;
	ASSoundController *soundController;
}

- (IBAction)searchWithIndex:(id)sender;
- (IBAction)searchWithName:(id)sender;
- (IBAction)setDate:(id)sender;
- (IBAction)setZip:(id)sender;
- (IBAction)setTown:(id)sender;
- (IBAction)indexChange:(id)sender;
- (IBAction)deleteModel:(id)sender;
- (IBAction)enroll:(id)sender;
- (IBAction)hagaki:(id)sender;
- (IBAction)report:(id)sender;
- (IBAction)sound:(id)sender;
- (IBAction)sendEmail:(id)sender;
- (IBAction)setEmail:(id)sender;
- (IBAction)goURL:(id)sender;
- (IBAction)setURL:(id)sender;
- (IBAction)postal:(id)sender;
- (IBAction)setPostalPrefec:(id)sender;
- (IBAction)prefecSet:(id)sender;
- (IBAction)prefecCancel:(id)sender;
- (IBAction)company:(id)sender;
- (IBAction)zipPopUped:(id)sender;
- (IBAction)locate:(id)sender;
- (IBAction)saveTovCard:(id)sender;
- (IBAction)saveToAddressBook:(id)sender;
  //
- (IBAction)saveToGroupInAddressBook:(id)sender;
  //
- (IBAction)groupOK:(id)sender;
- (IBAction)groupCancel:(id)sender;

@end
