/* Model.m created by SatoAkira on Sat 26-Jun-1999 */

#import "Model.h"

@implementation Model

- (id)init
{
	NSString *empty = @"";
	
	self = [super init];
	index = [[NSString alloc] initWithString:empty];
	rootIndex = [[NSString alloc] initWithString:empty];
	name = [[NSString alloc] initWithString:empty];
	nameKana = [[NSString alloc] initWithString:empty];
	post = [[NSString alloc] initWithString:empty];
	/* country = [[NSString alloc] initWithString:NSLocalizedStringFromTable(@"Japan",@"Enroll",@"日本")]; */
	/* 2002-07-16 変更 */
	country = [[NSString alloc] initWithString:NSLocalizedString(@"LocalCountry",@"日本")];
	zip = [[NSString alloc] initWithString:empty];
	prefecture = [[NSString alloc] initWithString:empty];
	city = [[NSString alloc] initWithString:empty];
	town = [[NSString alloc] initWithString:empty];
	address = [[NSString alloc] initWithString:empty];
	prefectureKana = [[NSString alloc] initWithString:empty];
	cityKana = [[NSString alloc] initWithString:empty];
	townKana = [[NSString alloc] initWithString:empty];
	telNumber = [[NSString alloc] initWithString:empty];
	faxNumber = [[NSString alloc] initWithString:empty];
	phsNumber = [[NSString alloc] initWithString:empty];
	email = [[NSString alloc] initWithString:empty];
	url = [[NSString alloc] initWithString:empty];
	type = [[NSString alloc] initWithString:empty];
	birthDay = [[NSString alloc] initWithString:empty];
	others = [[NSString alloc] initWithString:empty];
	locateX = locateY = locateZ = 2.0 * RADIUSOFGRS80;
	picture = nil;
	pictureFilename = [[NSString alloc] initWithString:empty];
#ifdef __APPLE__
	sound = nil;
#else
	sound = [[Sound alloc] init];
#endif
	soundFilename = [[NSString alloc] initWithString:empty];
	return self;
}

- (void)dealloc
{
	[index release];
	[rootIndex release];
	[name release];
	[nameKana release];
	[post release];
	[country release];
	[zip release];
	[prefecture release];
	[city release];
	[town release];
	[address release];
	[prefectureKana release];
	[cityKana release];
	[townKana release];
	[telNumber release];
	[faxNumber release];
	[phsNumber release];
	[email release];
	[url release];
	[type release];
	[birthDay release];
	[others release];
	[picture release];
	[pictureFilename release];
	[sound release];
	[soundFilename release];
	[super dealloc];
}

- (id)initWithCoder:(NSCoder *)coder
{
	index = [[coder decodeObject] copy];
	rootIndex = [[coder decodeObject] copy];
	name = [[coder decodeObject] copy];
	nameKana = [[coder decodeObject] copy];
	post = [[coder decodeObject] copy];
	country = [[coder decodeObject] copy];
	zip = [[coder decodeObject] copy];
	prefecture = [[coder decodeObject] copy];
	city = [[coder decodeObject] copy];
	town = [[coder decodeObject] copy];
	address = [[coder decodeObject] copy];
	prefectureKana = [[coder decodeObject] copy];
	cityKana = [[coder decodeObject] copy];
	townKana = [[coder decodeObject] copy];
	telNumber = [[coder decodeObject] copy];
	faxNumber = [[coder decodeObject] copy];
	phsNumber = [[coder decodeObject] copy];
	email = [[coder decodeObject] copy];
	url = [[coder decodeObject] copy];
	type = [[coder decodeObject] copy];
	birthDay = [[coder decodeObject] copy];
	others = [[coder decodeObject] copy];
	[coder decodeValueOfObjCType:"d" at:&locateX];
	[coder decodeValueOfObjCType:"d" at:&locateY];
	[coder decodeValueOfObjCType:"d" at:&locateZ];
	picture = [[coder decodeObject] copy];
	pictureFilename = [[coder decodeObject] copy];
	sound = [[coder decodeObject] copy];
	soundFilename = [[coder decodeObject] copy];
	return self;
}

- (void)encodeWithCoder:(NSCoder *)coder
{
	[coder encodeObject:index];
	[coder encodeObject:rootIndex];
	[coder encodeObject:name];
	[coder encodeObject:nameKana];
	[coder encodeObject:post];
	[coder encodeObject:country];
	[coder encodeObject:zip];
	[coder encodeObject:prefecture];
	[coder encodeObject:city];
	[coder encodeObject:town];
	[coder encodeObject:address];
	[coder encodeObject:prefectureKana];
	[coder encodeObject:cityKana];
	[coder encodeObject:townKana];
	[coder encodeObject:telNumber];
	[coder encodeObject:faxNumber];
	[coder encodeObject:phsNumber];
	[coder encodeObject:email];
	[coder encodeObject:url];
	[coder encodeObject:type];
	[coder encodeObject:birthDay];
	[coder encodeObject:others];
	[coder encodeValueOfObjCType:"d" at:&locateX];
	[coder encodeValueOfObjCType:"d" at:&locateY];
	[coder encodeValueOfObjCType:"d" at:&locateZ];
	[coder encodeObject:picture];
	[coder encodeObject:pictureFilename];
	[coder encodeObject:sound];
	[coder encodeObject:soundFilename];
}

/* static NSString *IndexKey = @"index";
static NSString *RootIndexKey = @"rootIndex";
static NSString *NameKey = @"name";
static NSString *NameKanaKey = @"nameKana";
static NSString *PostKey = @"post";
static NSString *CountryKey = @"country";
static NSString *ZipKey = @"zip";
static NSString *PrefectureKey = @"prefecture";
static NSString *CityKey = @"city";
static NSString *TownKey = @"town";
static NSString *AddressKey = @"address";
static NSString *PrefectureKanaKey = @"prefectureKana";
static NSString *CityKanaKey = @"cityKana";
static NSString *TownKanaKey = @"townKana";
static NSString *TelNumberKey = @"telNumber";
static NSString *FaxNumberKey = @"faxNumber";
static NSString *PhsNumberKey = @"phsNumberKey";
static NSString *EmailKey = @"email";
static NSString *UrlKey = @"url";
static NSString *TypeKey = @"type";
static NSString *BirthDayKey = @"birthDay";
static NSString *OthersKey = @"others";
static NSString *LocateXKey = @"locateX";
static NSString *LocateYKey = @"locateY";
static NSString *LocateZKey = @"locateZ";
static NSString *PictureKey = @"picture";
static NSString *PictureFilenameKey = @"pictureFilename";
static NSString *SoundKey = @"sound";
static NSString *SoundFilenameKey = @"soundFilename";

- (id)initWithCoder:(NSCoder *)coder
{
	index = [[coder decodeObjectForKey:IndexKey] retain];
	rootIndex = [[coder decodeObjectForKey:RootIndexKey] retain];
	name = [[coder decodeObjectForKey:NameKey] retain];
	nameKana = [[coder decodeObjectForKey:NameKanaKey] retain];
	post = [[coder decodeObjectForKey:PostKey] retain];
	country = [[coder decodeObjectForKey:CountryKey] retain];
	zip = [[coder decodeObjectForKey:ZipKey] retain];
	prefecture = [[coder decodeObjectForKey:PrefectureKey] retain];
	city = [[coder decodeObjectForKey:CityKey] retain];
	town = [[coder decodeObjectForKey:TownKey] retain];
	address = [[coder decodeObjectForKey:AddressKey] retain];
	prefectureKana = [[coder decodeObjectForKey:PrefectureKanaKey] retain];
	cityKana = [[coder decodeObjectForKey:CityKanaKey] retain];
	townKana = [[coder decodeObjectForKey:TownKanaKey] retain];
	telNumber = [[coder decodeObjectForKey:TelNumberKey] retain];
	faxNumber = [[coder decodeObjectForKey:FaxNumberKey] retain];
	phsNumber = [[coder decodeObjectForKey:PhsNumberKey] retain];
	email = [[coder decodeObjectForKey:EmailKey] retain];
	url = [[coder decodeObjectForKey:UrlKey] retain];
	type = [[coder decodeObjectForKey:TypeKey] retain];
	birthDay = [[coder decodeObjectForKey:BirthDayKey] retain];
	others = [[coder decodeObjectForKey:OthersKey] retain];
	locateX = [coder decodeDoubleForKey:LocateXKey];
	locateY = [coder decodeDoubleForKey:LocateYKey];
	locateZ = [coder decodeDoubleForKey:LocateZKey];
	picture = [[coder decodeObjectForKey:PictureKey] retain];
	pictureFilename = [[coder decodeObjectForKey:PictureFilenameKey] retain];
	sound = [[coder decodeObjectForKey:SoundKey] retain];
	soundFilename = [[coder decodeObjectForKey:SoundFilenameKey] retain];
	return self;
}

- (void)encodeWithCoder:(NSCoder *)coder
{
	[coder encodeObject:index forKey:IndexKey];
	[coder encodeObject:rootIndex forKey:RootIndexKey];
	[coder encodeObject:name forKey:NameKey];
	[coder encodeObject:nameKana forKey:NameKanaKey];
	[coder encodeObject:post forKey:PostKey];
	[coder encodeObject:country forKey:CountryKey];
	[coder encodeObject:zip forKey:ZipKey];
	[coder encodeObject:prefecture forKey:PrefectureKey];
	[coder encodeObject:city forKey:CityKey];
	[coder encodeObject:town forKey:TownKey];
	[coder encodeObject:address forKey:AddressKey];
	[coder encodeObject:prefectureKana forKey:PrefectureKanaKey];
	[coder encodeObject:cityKana forKey:CityKanaKey];
	[coder encodeObject:townKana forKey:TownKanaKey];
	[coder encodeObject:telNumber forKey:TelNumberKey];
	[coder encodeObject:faxNumber forKey:FaxNumberKey];
	[coder encodeObject:phsNumber forKey:PhsNumberKey];
	[coder encodeObject:email forKey:EmailKey];
	[coder encodeObject:url forKey:UrlKey];
	[coder encodeObject:type forKey:TypeKey];
	[coder encodeObject:birthDay forKey:BirthDayKey];
	[coder encodeObject:others forKey:OthersKey];
	[coder encodeDouble:locateX forKey:LocateXKey];
	[coder encodeDouble:locateY forKey:LocateYKey];
	[coder encodeDouble:locateZ forKey:LocateZKey];
	[coder encodeObject:picture forKey:PictureKey];
	[coder encodeObject:pictureFilename forKey:PictureFilenameKey];
	[coder encodeObject:sound forKey:SoundKey];
	[coder encodeObject:soundFilename forKey:SoundFilenameKey];
} */

- (void)setIndex:(NSString *)aString
{
	[index release];
	index = [[NSString alloc] initWithString:aString];
}
- (void)setRootIndex:(NSString *)aString
{
	[rootIndex release];
	rootIndex = [[NSString alloc] initWithString:aString];
}
- (void)setName:(NSString *)aString
{
	[name release];
	name = [[NSString alloc] initWithString:aString];
}
- (void)setNameKana:(NSString *)aString
{
	[nameKana release];
	nameKana = [[NSString alloc] initWithString:aString];
}
- (void)setPost:(NSString *)aString
{
	[post release];
	post = [[NSString alloc] initWithString:aString];
}
- (void)setCountry:(NSString *)aString
{
	[country release];
	country = [[NSString alloc] initWithString:aString];
}
- (void)setZip:(NSString *)aString
{
	[zip release];
	zip = [[NSString alloc] initWithString:aString];
}
- (void)setPrefecture:(NSString *)aString
{
	[prefecture release];
	prefecture = [[NSString alloc] initWithString:aString];
}
- (void)setCity:(NSString *)aString
{
	[city release];
	city = [[NSString alloc] initWithString:aString];
}
- (void)setTown:(NSString *)aString
{
	[town release];
	town = [[NSString alloc] initWithString:aString];
}
- (void)setAddress:(NSString *)aString
{
	[address release];
	address = [[NSString alloc] initWithString:aString];
}
- (void)setPrefectureKana:(NSString *)aString
{
	[prefectureKana release];
	prefectureKana = [[NSString alloc] initWithString:aString];
}
- (void)setCityKana:(NSString *)aString
{
	[cityKana release];
	cityKana = [[NSString alloc] initWithString:aString];
}
- (void)setTownKana:(NSString *)aString
{
	[townKana release];
	townKana = [[NSString alloc] initWithString:aString];
}
- (void)setTelNumber:(NSString *)aString
{
	[telNumber release];
	telNumber = [[NSString alloc] initWithString:aString];
}
- (void)setFaxNumber:(NSString *)aString
{
	[faxNumber release];
	faxNumber = [[NSString alloc] initWithString:aString];
}
- (void)setPhsNumber:(NSString *)aString
{
	[phsNumber release];
	phsNumber = [[NSString alloc] initWithString:aString];
}
- (void)setEmail:(NSString *)aString
{
	[email release];
	email = [[NSString alloc] initWithString:aString];
}
- (void)setUrl:(NSString *)aString
{
	[url release];
	url = [[NSString alloc] initWithString:aString];
}
- (void)setType:(NSString *)aString
{
	[type release];
	type = [[NSString alloc] initWithString:aString];
}
- (void)setBirthDay:(NSString *)aString;
{
	[birthDay release];
	birthDay = [[NSString alloc] initWithString:aString];
}
- (void)setOthers:(NSString *)aString
{
	[others release];
	others = [[NSString alloc] initWithString:aString];
}
- (void)setLocateX:(double)aValue
{
	locateX = aValue;
}
- (void)setLocateY:(double)aValue
{
	locateY = aValue;
}
- (void)setLocateZ:(double)aValue
{
	locateZ = aValue;
}
- (void)setPicture:(NSImage *)aImage
{
	[picture release];
	if (nil != aImage)
		picture = [aImage copyWithZone:[self zone]];
	else
		picture = nil;
}
- (void)setPictureFilename:(NSString *)aString
{
	[pictureFilename release];
	pictureFilename = [[NSString alloc] initWithString:aString];
}
#ifdef __APPLE__
- (void)setSound:(NSData *)aSound
{
	NSLog(@"setSound");
	[sound release];
	if ((nil != aSound) && (0 < [aSound length]))
		sound = [[NSData alloc] initWithData:aSound];
	else
		sound = nil;
}
#else
- (void)setSound:(Sound *)aSound
{
	[sound release];
	sound = [[Sound alloc] init];
	if ((nil != aSound) && (NO == [aSound isEmpty]))
		[sound copySound:aSound];
}
#endif
- (void)setSoundFilename:(NSString *)aString
{
	[soundFilename release];
	soundFilename = [[NSString alloc] initWithString:aString];
}

- (NSString *)index
{
	return index;
}
- (NSString *)rootIndex
{
	return rootIndex;
}
- (NSString *)name
{
	return name;
}
- (NSString *)nameKana
{
	return nameKana;
}
- (NSString *)post
{
	return post;
}
- (NSString *)country
{
	return country;
}
- (NSString *)zip
{
	return zip;
}
- (NSString *)prefecture
{
	return prefecture;
}
- (NSString *)city
{
	return city;
}
- (NSString *)town
{
	return town;
}
- (NSString *)address
{
	return address;
}
- (NSString *)prefectureKana
{
	return prefectureKana;
}
- (NSString *)cityKana
{
	return cityKana;
}
- (NSString *)townKana
{
	return townKana;
}
- (NSString *)telNumber
{
	return telNumber;
}
- (NSString *)faxNumber
{
	return faxNumber;
}
- (NSString *)phsNumber
{
	return phsNumber;
}
- (NSString *)email
{
	return email;
}
- (NSString *)url
{
	return url;
}
- (NSString *)type
{
	return type;
}
- (NSString *)birthDay
{
	return birthDay;
}
- (NSString *)others
{
	return others;
}
- (double)locateX
{
	return locateX;
}
- (double)locateY
{
	return locateY;
}
- (double)locateZ
{
	return locateZ;
}
- (NSImage *)picture
{
	return picture;
}
- (NSString *)pictureFilename
{
	return pictureFilename;
}
#ifdef __APPLE__
- (NSData *)sound
{
	return sound;
}
#else
- (Sound *)sound
{
	return sound;
}
#endif
- (NSString *)soundFilename
{
	return soundFilename;
}

- (NSInteger)nameCompare:(Model *)otherModel
{
	return [[self name] compare:[otherModel name] options:NSLiteralSearch];
}
- (NSInteger)addressCompare:(Model *)otherModel
{
	return [[NSString stringWithFormat:@"%@%@%@%@",[self prefecture],[self city],[self town],[self address]] compare:[NSString stringWithFormat:@"%@%@%@%@",[otherModel prefecture],[otherModel city],[otherModel town],[otherModel address]] options:NSLiteralSearch];
}
- (NSInteger)typeCompare:(Model *)otherModel
{
	return [[self type] compare:[otherModel type] options:NSLiteralSearch];
}
- (NSInteger)birthDayCompare:(Model *)otherModel
{
#if MAC_OS_X_VERSION_MAX_ALLOWED >= MAC_OS_X_VERSION_10_10
    NSDateFormatter *formatter = [[NSDateFormatter alloc] init];
    [formatter setFormatterBehavior:NSDateFormatterBehavior10_4];
    [formatter setDateFormat:@"yyyy-MM-dd"];
    NSDate *selfDate = (NO == [[self birthDay] isEqualToString:@""]) ? [formatter dateFromString:[self birthDay]] : [NSDate distantPast];
    NSDate *otherDate = (NO == [[otherModel birthDay] isEqualToString:@""]) ? [formatter dateFromString:[otherModel birthDay]] : [NSDate distantPast];
    [formatter release];
#else
    NSDate *selfDate = (NO == [[self birthDay] isEqualToString:@""]) ? [NSDate dateWithNaturalLanguageString:[self birthDay]] : [NSDate distantPast];
	NSDate *otherDate = (NO == [[otherModel birthDay] isEqualToString:@""]) ? [NSDate dateWithNaturalLanguageString:[otherModel birthDay]] : [NSDate distantPast];
#endif

	return [selfDate compare:otherDate];
}

@end
