/* HtmlFileAdaptor.h created by SatoAkira on Sat 26-Jun-1999 */

#import <AppKit/AppKit.h>
#import "Model.h"

@interface HtmlFileAdaptor : NSObject
{

}

- (id)init;
- (void)dealloc;
- (BOOL)write:(NSDictionary *)aDic toFile:(NSString *)path atomically:(BOOL)flag;
- (NSArray *)readFromFile:(NSString *)path;
- (void)removeModel:(Model *)aModel filename:(NSString *)path;
- (NSArray *)revertFromFile:(NSString *)path;
- (BOOL)indexChanged:(Model *)oldModel to:(NSString *)newIndex at:(NSString *)path;
/* 2002-07-16 追加 */
- (NSDictionary *)dictionaryWithModels:(NSArray *)anArray;
- (NSDictionary *)fileWrapperDictionary:(NSString *)source enroll:(NSMutableDictionary *)dic;

@end
